// This program tests board I2C-ER1001 the burst fire controller.
// This program runs on Arduino Uno board. The Arduino board interfaces the I2C-ER1001 via I2C bus 
//
// ERE Company Limited.
// https://www.ereshop.com

#include <Arduino.h>
#include <Wire.h>

#define I2C_ADR      (0x10)

static unsigned char i = 0;

bool  er1001_IsConnected (unsigned char adr)
{
  bool connect;

  Wire.beginTransmission(adr);
  if (Wire.endTransmission() == 0) {
    connect = true;
  } else {
    connect = false;
  }

  return (connect);
}

bool er1001_Rd(unsigned char adr, unsigned char *p_data, unsigned char nbyte) 
{
  bool available;

  if (er1001_IsConnected(adr) == true) {
    available = false;
    Wire.requestFrom(adr, nbyte);
    while (Wire.available()) {
      *p_data++ = Wire.read();
      available = true;
    }
  } else {
    available = false;
  }

  return (available);
}

void er1001_Wr(unsigned char adr, unsigned char data) 
{
  Wire.beginTransmission(adr);
  Wire.write(data);
  Wire.endTransmission();

  return;
}

void setup() {

  // put your setup code here, to run once:
  Wire.begin();
  Wire.setClock(400000uL);                   // I2C frequency 400Khz
  Serial.begin(9600);                        // set serial board rate 9600
  Serial.println("Start ER1001");            
}

void loop() {
  // put your main code here, to run repeatedly:
  unsigned char buf;

  er1001_Wr(I2C_ADR, i);                     // write duty cycle
  delay(200);                                // delay must grater than period of I2C-ER1001(200ms)   

  if (er1001_Rd(I2C_ADR, &buf, 1)) {         // test reading duty cycle
    Serial.println(buf, DEC);
  } else {
    Serial.println("Fail reading"); 
  }

  i++;                                       // increase duty cycle from 0 to 10 steps 
  if (i > 10) {
    i = 0u;
  }

}

